flux = require "flux.flux"

function love.load()
    --if you change filter to linear, movement is smooth, but pixels also smoothed which I don't want
    love.graphics.setDefaultFilter("nearest","nearest")

    box = love.graphics.newImage("box1.png")
    camera = {x = 0, y = 0}

    --in my main project I do need to draw on to canvas
    myCanvas = love.graphics.newCanvas(320,200)
end

function love.update(dt)
    --update tween engine
    flux.update(dt)

    --tween camera to 800, 600 over 200 seconds
    --slower the movement the more noticable the jitter is
    --it is important to move the camera over time or at a certian speed
    flux.to(camera, 200, {x = 800, y = 600})
end

function love.draw()

    --draw box on to canvas with translation of camera
    --it is need to be done this way and the object need to be drawn over and over again in my main project
    love.graphics.setCanvas(myCanvas)
    love.graphics.clear()
    love.graphics.push()
    love.graphics.translate(camera.x, camera.y)
    love.graphics.draw(box,0,0,0,2,2)
    love.graphics.pop()
    love.graphics.setCanvas()

    --draw canvas with scale to fill the entire window
    love.graphics.draw(myCanvas,0,0,0,800/320,600/200)
end